//  WinApi
#define _CRT_SECURE_NO_WARNINGS
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <Windows.h>
// 
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#define ERROR_OPEN_FILE -3
#define input_F "input.txt"
#define Linput_F L"input.txt"
#define Loutput_F L"output.txt"
#define output_F "output.txt"
#define ZERO 0.0

void problemFileRead(FILE* file)
{
	if (file == NULL)
	{
		printf("   %s", file);
		getchar();
		exit(ERROR_OPEN_FILE);
	}
}

void problemFileWrite(FILE* file1, FILE* file2)
{
	if (file1 == NULL)
	{
		printf("   %s", file1);
		getchar(); \
			if (file2 != NULL) { fclose(file2); }
		exit(ERROR_OPEN_FILE);
	}
}

int is_number(char* str)
{
	char* end;
	strtod(str, &end);
	return *str != '\0' && *end == '\0';
}

int main()
{
	system("chcp 1251>nul");
	HANDLE inputF;
	inputF = CreateFile(Linput_F, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	problemFileRead(inputF);
	
	HANDLE outputF;
	outputF = CreateFile(Loutput_F, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	problemFileWrite(outputF, inputF);
	

	double a = ZERO, b = ZERO, c = ZERO, x1, x2;

#pragma region readFileInStr

	size_t sizeFile = GetFileSize(inputF, NULL);
	char* buf = (char*)malloc(sizeFile * sizeof(char));
	if (!buf) {
		printf("  ");
		fclose(inputF);
		return NULL;
	}

	DWORD bytesRead;
	BOOL resultR = ReadFile(inputF, buf, strlen(buf), &bytesRead, NULL);
	if (!resultR)
	{
		printf("  !  : %d\n", GetLastError());		;
		CloseHandle(inputF);
		return 1;
	}	
	buf[bytesRead] = '\0';
	CloseHandle(inputF);

#pragma endregion

#pragma region preobrazovanie

	char str[100];
	DWORD bytesWrite;
	BOOL resultW;
	size_t lenght = strlen(buf);
	for (int i = 0; i < lenght; i++)
	{
		if ( isdigit((char)buf[i]) || (char)buf[i] == '.' 
			|| buf[i] == ' ' || buf[i] == '\r' || buf[i] == '\n' || buf[i] == '\t' || (char)buf[i] == '-')
		{
			if (!(isdigit((char)buf[i]) || (char)buf[i] == '.' || (char)buf[i] == '-'))
			{
				buf[i] = ' ';
			}
			else continue;
		}
		else
		{
			printf("!  !");
			sprintf(str, "!  !");
			resultW = WriteFile(outputF, str, strlen(str), &bytesWrite, NULL);
			if (!resultW)
			{
				printf("  !  : %d\n", GetLastError()); ;
				CloseHandle(outputF);
				return 1;
			}
			CloseHandle(outputF);
			printf("\n    %s\n", output_F);
			free(buf);
			return -1;
		}		
	}
	int count = 0;
	char* copy = (char*)malloc((lenght + 1) * sizeof(char));
	strcpy(copy, buf);

	char* pars = strtok(copy, " ");

	while (pars != NULL)
	{
		if (is_number(pars) && count < 3)
		{
			if (strcmp(pars, "-0") == 0)
			{
				pars = "0";
			}
			if (count == 0) a = atof(pars);
			else if (count == 1) b = atof(pars);
			else if (count == 2) c = atof(pars);
			count++;
		}
		else if (count > 3)
		{
			break;
		}
		pars = strtok(NULL, " ");
	}

	printf("   : a = %lf, b = %lf, c = %lf", a, b, c);
	sprintf(str,"   : a = %lf, b = %lf, c = %lf", a, b, c);
	resultW = WriteFile(outputF, str, strlen(str), &bytesWrite, NULL);
	
	if (!resultW)
	{
		printf("  !  : %d\n", GetLastError()); ;
		CloseHandle(outputF);
		return 1;
	}

#pragma endregion

#pragma region Descriminant

	if ((a == ZERO && b == ZERO && c == ZERO) || (a == ZERO && b == ZERO && c != ZERO))
	{
		printf("\n  ,       %0.0f\n", ZERO);
		sprintf(str, "\n  ,       %0.0f\n", ZERO);
	}
	else if (a != ZERO && b == ZERO && c == ZERO)
	{
		x1 = x2 = ZERO;
		printf("\n  : X1 = X2 = %0.0f.   ,    b  c  %0.0f", x1, ZERO);
		sprintf(str, "\n  : X1 = X2 = %0.0f.   ,    b  c  %0.0f", x1, ZERO);
	}
	else if (a != ZERO && b != ZERO && c == ZERO)
	{
		x1 = ZERO;
		x2 = (b * (-1)) / a;
		printf("\n  : X1 = %0.0f, X2 = %0.3f.   ,    c = %0.0f", x1, x2, c);
		sprintf(str, "\n  : X1 = %0.0f, X2 = %0.3f.   ,    c = %0.0f", x1, x2, c);
	}
	else if (a != ZERO && b == ZERO && c != ZERO)
	{
		if (((c * (-1)) / a) < ZERO)
		{
			if (c < ZERO && a < ZERO)
			{
				printf("\n ,   c = %0.3f  0  a = %0.3f  0", c, a);
				sprintf(str, "\n ,   c = %0.3f  0  a = %0.3f  0", c, a);
			}
			else if (a > ZERO && c > ZERO)
			{
				printf("\n ,   a = %0.3f  0  c = %0.3f  0", a, c);
				sprintf(str, "\n ,   a = %0.3f  0  c = %0.3f  0", a, c);
			}
		}
		else
		{
			double m = (c * (-1)) / a;
			x1 = sqrt(m);
			x2 = -sqrt(m);

			printf("\n  : X1 = %0.3f, X2 = %0.3f.   ,    b = %0.0f", x1, x2, b);
			sprintf(str, "\n  : X1 = %0.3f, X2 = %0.3f.   ,    b = %0.0f", x1, x2, b);
		}
	}
	else if (a == ZERO && b != ZERO && c != ZERO)
	{
		x1 = x2 = b / (c * (-1));
		printf("\n  : X1 = X2 = %0.3f.   ,    a = %0.0f", x1, a);
		sprintf(str, "\n  : X1 = X2 = %0.3f.   ,    a = %0.0f", x1, a);
	}
	else if (a != ZERO && b != ZERO && c != ZERO)
	{
		double D = b * b - 4.0f * a * c;
		if (D > ZERO)
		{
			x1 = (sqrt(D) - b) / (2.0f * a);
			x2 = -(sqrt(D) + b) / (2.0f * a);
			printf("\n  : X1 = %0.3f, X2 = %0.3f.  = %0.3f", x1, x2, D);
			sprintf(str, "\n  : X1 = %0.3f, X2 = %0.3f.  = %0.3f", x1, x2, D);
		}
		else if (D == ZERO)
		{
			x1 = x2 = -b / (2.0f * a);
			printf("\n  : X1 = X2 = %0.3f.  = %0.3f", x1, D);
			sprintf(str, "\n  : X1 = X2 = %0.3f.  = %0.3f", x1, D);
		}
		else
		{
			printf("\n  .  = %0.3f", D);
			sprintf(str, "\n  .  = %0.3f", D);
		}
	}

#pragma endregion

	resultW = WriteFile(outputF, str, strlen(str), &bytesWrite, NULL);
	if (!resultW)
	{
		printf("  !  : %d\n", GetLastError()); ;
		CloseHandle(outputF);
		return 1;
	}
	CloseHandle(outputF);
	printf("\n    %s\n", output_F);
}